<div id="container_badheader"><table>
  <tr id="row_badheader_comment" class="enabled"><td colspan="3" class="comment">
    The mail filter can check incoming mail for bad mail headers.<br/>
    Here you can configure, whether or not you want to enable the check for bad mail headers<br/>
    and what should happen when the mail filter detects a mail with a bad headers.<br/><br/>
    If you decide to receive mails with bad headers, you can create server side filters (using SIEVE)<br/>
    or use your email clients filter capabilities to handle such mail in a special way (based on mail headers added by the mail filter).<br/><br/>
    It is not a bad idea to enable the check for bad headers. But because a lot of mails may be "bad",<br/>
    you should not enable quarantining, but instead enable the delivery to the final recipient. This way you will not miss<br/>
    mails just because the mail filter detected a bad header. <br/>
    You can use a recipient address extension and/or server- or client-side filter rules to "mark" emails with bad headers.
    <br/><br/><hr/>
  </td></tr>

  <tr id="row_badheader_enabled" class="enabled"><td><b>Enable check for bad headers:</b></td>
    <td><select name="badheader_enabled" id="badheader_enabled" size="1" onchange="updateFormBadHeader()">
      <option value="1" <?php echo ($data["bypass_header_checks"]=="N")?"selected=\"selected\"":""; ?>>Yes</option>
      <option value="0" <?php echo ($data["bypass_header_checks"]=="Y")?"selected=\"selected\"":""; ?>>No</option>
    </select></td>
    <td class="comment">When disabled no checking for bad mail headers will be done.</td>
  </tr>
  <tr id="row_badheader_quarantine"><td><b>Store mails with bad headers in quarantine:</b></td>
    <td><select name="badheader_quarantine" id="badheader_quarantine" size="1" onchange="updateFormBadHeader()">
      <option value="1" <?php echo ( $data["bad_header_quarantine_to"])?"selected=\"selected\"":""; ?>>Yes</option>
      <option value="0" <?php echo (!$data["bad_header_quarantine_to"])?"selected=\"selected\"":""; ?>>No</option>
    </select></td>
    <td class="comment">When you enable this option, a mail with bad headers can be stored in a quarantine or sent to a special
      email address. This is most useful when you disable <em>"Deliver mails with bad headers to final recipient"</em>,
      so mails with bad headers will not be lost.
    </td>
  </tr>
  <tr id="row_badheader_quarantine_to"><td><b>Where to quarantine mails with bad headers:</b></td>
    <td><select name="badheader_quarantine_to" id="badheader_quarantine_to" size="1" onchange="updateFormBadHeader()">
      <option value="email" <?php echo (!strpos($data["bad_header_quarantine_to"],"@")===false)?"selected=\"selected\"":""; ?>>Send email</option>
      <option value="file"  <?php echo ( strpos($data["bad_header_quarantine_to"],"@")===false)?"selected=\"selected\"":""; ?>>Save as file</option>
    </select></td>
    <td class="comment">You can choose between storing mails with bad headers in a special directory on the mailserver (<em>"Save as file"</em>)
      or send it via email to another email address ("<em>Send email</em>"). If you choose to send an email, make sure this recipient
      accepts mails with bad headers! You could configure a special email address for this with "<em>Enable check for bad headers</em>" 
      set to "<em>No</em>".<br/>
      The directory where mails with bad headers will be quarantined if you choose "<em>Save as file</em>" can NOT be configured on a per user basis,
      so dont ask ;-)
    </td>
  </tr>
  <tr id="row_badheader_quarantine_email"><td><b>Email address for quarantine:</b></td>
    <td><input type="text" id="badheader_quarantine_email" name="badheader_quarantine_email" value="<?php echo (strpos($data["bad_header_quarantine_to"],"@")===false)?"":$data["bad_header_quarantine_to"]; ?>" size="20"/></td>
    <td class="comment">The email address where mails with bad headers have to be sent to.</td>
  </tr>
  <tr id="row_badheader_notify_admin"><td><b>Send notification about mails with bad headers to admin:</b></td>
    <td><select name="badheader_notify_admin" id="badheader_notify_admin" size="1" onchange="updateFormBadHeader()">
      <option value="1" <?php echo ( $data["bad_header_admin"])?"selected=\"selected\"":""; ?>>Yes</option>
      <option value="0" <?php echo (!$data["bad_header_admin"])?"selected=\"selected\"":""; ?>>No</option>
    </select></td>
    <td class="comment">When a mail with bad headers is detected we can automatically send a notification about this mail
      to a special email address (e.g. a postmaster who collects statistics about bad headers). 
      This notification mail contains the sender and recipient of the bad mail, some meta data
      (extracted from the mail headers) and some information about the bad headers itself.
    </td>
  </tr>
  <tr id="row_badheader_notify_admin_email"><td><b>Email address to send notifications to:</b></td>
    <td><input type="text" id="badheader_notify_admin_email" name="badheader_notify_admin_email" value="<?php echo $data["bad_header_admin"]; ?>" size="20"/></td>
    <td class="comment">The mail address where notification emails concerning bad headers should be sent to.</td>
  </tr>
  <tr id="row_badheader_lover"><td><b>Deliver mails with bad headers to final recipient:</b></td>
    <td><select name="badheader_lover" id="badheader_lover" size="1" onchange="updateFormBadHeader()">
      <option value="1" <?php echo ($data["bad_header_lover"]=="Y")?"selected=\"selected\"":""; ?>>Yes</option>
      <option value="0" <?php echo ($data["bad_header_lover"]=="N")?"selected=\"selected\"":""; ?>>No</option>
    </select></td>
    <td class="comment">When a mail with bad headers is detected you can decide whether or not to receive this email. When you set this option to
      "<em>Yes</em>" you will receive the mail. When you set this to "<em>No</em>", you will NOT receive the mail. In this case you should enable
      the option "<em>Store mails with bad headers in quarantine</em>" to prevent you from really loosing mail.
    </td>
  </tr>
  <tr id="row_badheader_notify_recpt"><td><b>Inform recipient about mails with bad headers in quarantine:</b></td>
    <td><select name="badheader_notify_recpt" id="badheader_notify_recpt" size="1">
      <option value="1" <?php echo ($data["warnbadhrecip"]=="Y")?"selected=\"selected\"":""; ?>>Yes</option>
      <option value="0" <?php echo ($data["warnbadhrecip"]=="N")?"selected=\"selected\"":""; ?>>No</option>
    </select></td>
    <td class="comment">If you decided not to receive mails with bad headers, and if you have enabled the quarantine mechanism,
      you can set this option to "<em>Yes</em>" to receive a notification mail telling you that we received a mail with bad headers
      for you which has been moved into quarantine. This notification email will contain a "reference id" for your
      email. If you really want to get this mail, ask your mail administrator to release the mail with this "reference id"
      from the quarantine.<br/>
      <em>TODO: Releasing mail from quarantine does not work until now. Currently the mail administrator has to extract
      the mail manually from the quarantine and send you the quarantine file.</em>
    </td>
  </tr>
  <tr id="row_badheader_addr_extension"><td><b>Add recipient address extension for mails with bad headers:</b></td>
    <td><select name="badheader_addr_extension" id="badheader_addr_extension" size="1" onchange="updateFormBadHeader()">
      <option value="1" <?php echo ( $data["addr_extension_bad_header"])?"selected=\"selected\"":""; ?>>Yes</option>
      <option value="0" <?php echo (!$data["addr_extension_bad_header"])?"selected=\"selected\"":""; ?>>No</option>
    </select></td>
    <td class="comment">If you decided to receive mails with bad headers you can automatically modify the recipient address using an "address
      extension". This means, when your email address is "alice@anywhere.com", and you enable this feature and set "<em>Address extension to
      be used</em>" (see below) to "badheader", the final recipient will be "alice+badheader@anywhere.com". <br/>
      One special advantage of this: if you have an IMAP account on this mail server, and if you have an IMAP folder called "badheader"
      below your INBOX, this extension mechanism will make the email automatically to be stored in this "badheader" folder
      (i.e. no need to use SIEVE for this).<br/>
      If this does not work for you, please contact your mail administrator - it's probably a permission problem (missing "anyone p" permission).<br/>
      <em>TODO: verify if this really works!</em>
    </td>
  </tr>
  <tr id="row_badheader_addr_extension_txt"><td><b>Address extension to be used:</b></td>
    <td><input type="text" id="badheader_addr_extension_txt" name="badheader_addr_extension_txt" value="<?php echo $data["addr_extension_bad_header"]; ?>" size="10"/></td>
    <td class="comment">The address extension to be used for receiving mails with bad headers. For users with an own IMAP account on this mail
      server this causes the mail system to store the received mail in the IMAP folder with the same name as the address extension given here.
    </td>
  </tr>
</table></div>
