<?php
  include("config.php");
  include("tools.php");

  function getMaxAgeNameByValue($value)
  {
    global $timeblocks;

    $name = "(unknown)";
    foreach ($timeblocks as $n => $maxage) {  
      if ((int)$value == (int)$maxage) {
        $name = $n;
        break;
      }
    }
    return $name;
  }

  function reverseDomain($domain)
  {
    return implode(".", array_reverse(explode(".", $domain)));
  }

  $userid = $_SERVER["PHP_AUTH_USER"];
  $db     = DB_connect($DBHOST, $DBUSER, $DBPASS, $DBNAME);
  
  if ($_REQUEST["limit"]) {
    $limit  = $_REQUEST["limit"];
  } else {
    $limit  = 20;
  }

  $results = DB_query($db, "SELECT * FROM adminusers WHERE userid='" . $userid . "'");
  $isadmin = DB_num_rows($results)!=0;
  DB_free_result($results);
  if ($isadmin) {
    $fromclause = "$MAILSVIEW m";
    $userrestriction = "TRUE";
  } else {
    $fromclause = "$MAILSVIEW m 
      JOIN userauth ua ON m.user_id=ua.email_id";
    $userrestriction = "ua.userid='".$userid."'";
  }

  $contents = array("V" => "Virus infected",
                    "B" => "Banned attachment type",
		    "S" => "Spam",
		    "s" => "Spammy",
		    "M" => "Bad MIME header",
		    "H" => "Bad header",
		    "O" => "Too large",
		    "C" => "Clean");
  $quarantines = array(" " => "Not quarantined",
                       "F" => "Quarantined to file",
		       "Z" => "Quarantined to ZIP file",
		       "B" => "Quarantined via BSMTP",
		       "Q" => "Quarantined to SQL database",
		       "M" => "Quarantined to mailbox");
  $deliveries = array("P" => "Passed to final recipient",
                      "R" => "Rejected",
		      "B" => "Bounced",
		      "D" => "Discarded",
		      "T" => "Temporary failure");
  $spamblocks = array("-10000,-5", "-5,0", "0,3", "3,4", "4,5", "5,6", "6,7", "7,8", "8,10000");

  $min=60; $hour=60*$min; $day=24*$hour; $week=7*$day; $month=30*$day;
  $timeblocks = array("1 hour" => 1*$hour, 
		      "6 hours" => 6*$hour, 
		      "12 hours" => 12*$hour, 
		      "24 hours" => 1*$day, 
		      "48 hours" => 2*$day, 
		      "1 week" => 1*$week, 
		      "2 weeks" => 2*$week, 
		      "1 month" => 1*$month, 
		      "2 months" => 2*$month, 
		      "6 months" => 6*$month,
		      "very old" => 10000*$month);

  $tags      = explode(",", $_REQUEST["tags"]);
  $values    = explode(",", $_REQUEST["values"]);
  $queries   = array();
  $headlines = array();
  $l         = count($tags);

  for ($i=0; $i<$l; $i++) {
    $tag   = $tags[$i];
    $value = $values[$i];

    switch ($tag) {
      case "policy":
        $query = "(policy_id=$value)";

        $results = DB_query($db, "SELECT policy_name FROM policy WHERE id=$value");
	$result  = DB_fetch_assoc($results);
	$p       = $result["policy_name"];
	DB_free_result($results);

        $headline = "policy <em>$p</em>";
        break;

      case "sid":
        $query = "(sid=$value)";

        $results = DB_query($db, "SELECT email FROM maddr WHERE id=$value");
	$result  = DB_fetch_assoc($results);
	$e       = $result["email"];
	DB_free_result($results);

        $headline = "sender <em>$e</em>";
        break;

      case "sdomain":
        $revdomain = reverseDomain($value);
        $query = "(sdomain='$revdomain')";
	$headline = "sender domain $value";
	break;

      case "rid":
        $query = "(rid=$value)";
        
	$results = DB_query($db, "SELECT email FROM maddr WHERE id=$value");
	$result  = DB_fetch_assoc($results);
	$e       = $result["email"];
	DB_free_result($results);

        $headline = "recipient <em>$e</em>";
        break;

      case "rdomain":
        $revdomain = reverseDomain($value);
        $query = "(rdomain='$revdomain')";
	$headline = "recipient domain $value";
	break;

      case "client_addr":
        $query = "(client_addr='" . $value . "')";
        $headline = "client host with IP address <em>$value</em>";
        break;

      case "content":
        $query = "(content='" . $value . "')";
        $headline = "mails of type <em>" . $contents[$value] . "</em>";
        break;

      case "quar_type":
        $query = "(quar_type='" . $value . "')";
        $headline = "mails <em>" . $quarantines[$value] . "</em>";
        break;

      case "ds":
        $query = "(ds='" . $value . "')";
        $headline = "mails with delivery status <em>" . $deliveries[$value] . "</em>";
        break;

      case "spam_level":
        $vs = explode(";", $value);
        $v1 = $vs[0];
        $v2 = $vs[1];
        $query = "(spam_level>=$v1 and spam_level<$v2)";
        $headline = "mail with spam level between $v1 (inclusive) and $v2 (exclusive)";
        break;

      case "maxage":
        $descr = getMaxAgeNameByValue($value);
	$query = "($DBNOW-time_num <= $value)";
	$headline = "mails not older than $descr";
	break;
    }
    if ($query) {
      $queries[]   = $query;
      $headlines[] = $headline;
    }
  }

  if (count($queries)!=0) {
    $query = " AND " . implode(" AND ", $queries);
  }

  $results = DB_query($db, "SELECT COUNT(*) 
    FROM $fromclause 
    WHERE $userrestriction 
    " . $query);
  $row     = DB_fetch_array($results);
  $total   = $row[0];
  DB_free_result($results);
?>
